<?xml version="1.0"?>

<!--
	XSLT transform for making a colour HTML file out of a devtodo XML database.

	This was half derived from the XSLT transform from Daniel Patterson and
	half from the transform by Mark Eichin.

	It will output the todo database as colourised HTML, with done items struck
	out.

	If anybody has ANY enhancements to this file, PLEASE send them to me, as I
	have very little clue WRT XSLT and this file is just a hack.

	I generate HTML output with the following line (via libxslt):

		xsltproc todo-html.xslt .todo > ../todo.html
-->

<xsl:stylesheet xsl:version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:output xsl:method="xml" xsl:indent="yes"/>
	<xsl:strip-space xsl:elements="item bulletlist"/> -->
	<xsl:preserve-space xsl:elements="preformatted"/>

	<!-- body -->
	<xsl:template xsl:match="/">
		<xsl:call-template xsl:name="noteList"/>
	</xsl:template>

	<xsl:template xsl:name="noteList">
		<todo>
		<xsl:for-each xsl:select="todo/note">
			<xsl:call-template xsl:name="noteItem"/>
		</xsl:for-each>
		</todo>
	</xsl:template>

	<xsl:template xsl:name="noteItem"><xsl:apply-templates xsl:select="."/></xsl:template>

	<xsl:template xsl:match="note">
		<xsl:call-template xsl:name="baseNote"/>
		<xsl:for-each xsl:select="./note">
			<xsl:call-template xsl:name="noteItem"/>
		</xsl:for-each>
	</xsl:template>

	<xsl:template xsl:name="baseNote">
		<item>
		<xsl:choose>
			<xsl:when xsl:test="@priority = 'veryhigh'"><veryhigh/></xsl:when>
			<xsl:when xsl:test="@priority = 'high'"><high/></xsl:when>
			<xsl:when xsl:test="@priority = 'medium'"><medium/></xsl:when>
			<xsl:when xsl:test="@priority = 'low'"><low/></xsl:when>
			<xsl:when xsl:test="@priority = 'verylow'"><verylow/></xsl:when>
			<xsl:otherwise><normal/></xsl:otherwise>
		</xsl:choose>
		<!-- Done -->
		<xsl:if xsl:test="@done">- <xsl:value-of xsl:select="child::text()"/></xsl:if>
		<!-- Not done -->
		<xsl:if xsl:test="not(@done)">- <xsl:value-of xsl:select="child::text()"/></xsl:if>
		<normal/>
		</item>
	</xsl:template>

</xsl:stylesheet>
